/* Copyright (c) 2009 Ondrej Donek.
   See the file LICENSE.txt for licensing information. */

// Some constants
if(typeof(CC) == "undefined") const CC = Components.classes;  
if(typeof(CI) == "undefined") const CI = Components.interfaces; 
if(typeof(CU) == "undefined") const CU = Components.utils;

if(typeof(XUL_NS) == "undefined") 
	const XUL_NS  = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

// Our namespace
if(typeof(extensions) == "undefined") var extensions = {};
if(typeof(extensions.tbnotes) == "undefined") extensions.tbnotes = {};

// Some URLs to icons
const TBNOTES_MSGHASNOTE_ICON_URL = "chrome://tbnotes/skin/icons/note-flag16x16.png";
const TBNOTES_MSGHASNONOTE_ICON_URL = "chrome://tbnotes/skin/icons/note-no-flag16x16.png";

// Note dialog constants
const TBNOTES_NOTEDLG_URI = "chrome://tbnotes/content/note-dialog.xul";
const TBNOTES_NOTEDLG_FTRS = "chrome,extrachrome,dialog,toolbar,modal,resizable=yes";

// Main tbNotes preferences key
const TBNOTES_PREFS_KEY = "extensions.tbnotes.";

try {
	// Needed for access to tbNotes preferences.
	const TBNOTES_PREFS = CC["@mozilla.org/preferences-service;1"].
			getService(CI.nsIPrefBranch);
} catch(e) {
	CU.reportError("tbNotes: error when initializing preferences service!");
}

/**
 * Helper function that returns current date and time (e.g. "2009-09-16 14:33:00").
 * 
 * @return string
 */
function getCurrentDatetime() {
	var d = new Date();
	var now = d.getFullYear() + "-" + 
			((d.getMonth()<10) ? "0" + d.getMonth() : d.getMonth()) + "-" + 
			((d.getDate()<10) ? "0" + d.getDate() : d.getDate()) + " " + 
			((d.getHours()<10) ? "0" + d.getHours() : d.getHours()) + ":" + 
			((d.getMinutes()<10) ? "0" + d.getMinutes() : d.getMinutes()) + ":00";

	return now;
}
