/* Copyright (c) 2009 Ondrej Donek.
   See the file LICENSE.txt for licensing information. */

/**
 * Handler for our note column in the main Thunderbird's messages tree.
 * 
 * @link http://developer.mozilla.org/en/Extensions/Thunderbird/Creating_a_Custom_Column 
 * @type Object
 */
var gTbNotesColumnHandler = {

	getCellText: function(aRow, aCol) {
		// We have image not a string
		return "";
	},

	getImageSrc: function(aRow, aCol) {
		var key  = gDBView.getKeyAt(aRow);
		// TODO This can be quit slowly when we have a lot of messages to check.
		//      Maybe will better to get all messages at once and check only if 
		//      target key is present in that array ...
		var note = extensions.tbnotes.checkNoteForMessageKey(key);
		
		return (note === true) 
				? TBNOTES_MSGHASNOTE_ICON_URL 
				: TBNOTES_MSGHASNONOTE_ICON_URL;
	},

	isString: function() { 
		return false; 
	},

	getSortStringForRow: function(aHdr) {
		CU.reportError(aHdr);
		return "";
	},

	getCellProperties: function(aRow, aCol, aProps) {},
	getRowProperties: function(aRow, aProps) {},
	getSortLongForRow: function(aHdr) { 
		return 0; 
	}
	
};

/**
 * Implements Components.interfaces.nsIObserver for message "MsgCreateDBView".
 * 
 * @type Object
 */
var gTbNotesCreateDbObserver = {

	observe: function(aMsgFolder, aTopic, aData) {  
		gDBView.addColumnHandler("tbn-note-treecol", gTbNotesColumnHandler);
	}
	
};


// ============================================================================
// Add on load event listener

window.addEventListener("load", extensions.tbnotes.onLoad, false);

